---
title: Element.insertAdjacentElement()
slug: Web/API/Element/insertAdjacentElement
tags:
  - API
  - DOM
  - Element
  - Gecko
  - Method
  - Reference
  - insertAdjacentElement
---
<p>{{APIRef("DOM")}}</p>

<p>The <strong><code>insertAdjacentElement()</code></strong> method of the {{domxref("Element")}} interface inserts a given element node at a given position relative to the element it is invoked upon.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><em>targetElement</em>.insertAdjacentElement(<em>position</em>, <em>element</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>position</code></dt>
 <dd>A {{domxref("DOMString")}} representing the position relative to the <code>targetElement</code>; must match (case-insensitively) one of the following strings:
 <ul>
  <li><code style="color: red;">'beforebegin'</code>: Before the <code>targetElement</code> itself.</li>
  <li><code style="color: green;">'afterbegin'</code>: Just inside the <code>targetElement</code>, before its first child.</li>
  <li><code style="color: blue;">'beforeend'</code>: Just inside the <code>targetElement</code>, after its last child.</li>
  <li><code style="color: magenta;">'afterend'</code>: After the <code>targetElement</code> itself.</li>
 </ul>
 </dd>
 <dt><code>element</code></dt>
 <dd>The element to be inserted into the tree.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>The element that was inserted, or <code>null</code>, if the insertion failed.</p>

<h3 id="Exceptions">Exceptions</h3>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Exception</th>
   <th scope="col">Explanation</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>SyntaxError</code></td>
   <td>The <code>position</code> specified is not a recognised value.</td>
  </tr>
  <tr>
   <td><code>TypeError</code></td>
   <td>The <code>element</code> specified is not a valid element.</td>
  </tr>
 </tbody>
</table>

<h3 id="Visualization_of_position_names">Visualization of position names</h3>

<pre class="notranslate">&lt;!-- <strong><code style="color: red;">beforebegin</code></strong> --&gt;
<code style="font-weight: bold;">&lt;p&gt;</code>
  &lt;!-- <strong><code style="color: green;">afterbegin</code></strong> --&gt;
  foo
  &lt;!-- <strong><code style="color: blue;">beforeend</code></strong> --&gt;
<code style="font-weight: bold;">&lt;/p&gt;</code>
&lt;!-- <strong><code style="color: magenta;">afterend</code></strong> --&gt;</pre>

<div class="note"><strong>Note:</strong> The <code>beforebegin</code> and <code>afterend</code> positions work only if the node is in a tree and has an element parent.</div>

<h2 id="Example">Example</h2>

<pre class="brush: js notranslate">beforeBtn.addEventListener('click', function() {
  var tempDiv = document.createElement('div');
  tempDiv.style.backgroundColor = randomColor();
  if (activeElem) {
    activeElem.insertAdjacentElement('beforebegin', tempDiv);
  }
  setListener(tempDiv);
});

afterBtn.addEventListener('click', function() {
  var tempDiv = document.createElement('div');
  tempDiv.style.backgroundColor = randomColor();
  if (activeElem) {
    activeElem.insertAdjacentElement('afterend', tempDiv);
  }
  setListener(tempDiv);
});</pre>

<p>Have a look at our <a href="https://mdn.github.io/dom-examples/insert-adjacent/insertAdjacentElement.html">insertAdjacentElement.html</a> demo on GitHub (see the <a href="https://github.com/mdn/dom-examples/blob/master/insert-adjacent/insertAdjacentElement.html">source code</a> too.) Here, we have a sequence of {{htmlelement("div")}} elements inside a container. When one is clicked, it becomes selected and you can then press the <em>Insert before</em> and <em>Insert after</em> buttons to insert new divs before or after the selected element using <code>insertAdjacentElement()</code>.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('DOM WHATWG', '#dom-element-insertadjacentelement', 'insertAdjacentElement()')}}</td>
   <td>{{ Spec2('DOM WHATWG') }}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">
<p>The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>
</div>

<p>{{Compat("api.Element.insertAdjacentElement")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("Element.insertAdjacentHTML()")}}</li>
 <li>{{domxref("Element.insertAdjacentText()")}}</li>
 <li>{{domxref("Node.insertBefore()")}} (similar to <code>beforebegin</code>, with different arguments)</li>
 <li>{{domxref("Node.appendChild()")}} (same effect as <code>beforeend</code>)</li>
</ul>
